/*
********************************************************
ULTRASONIC Water level Indicator using ESP8266-01
********************************************************
*/
//#define TRIGGER 4
//#define ECHO    5

#define TRIGGER 0 // for esp8266-01
#define ECHO    2 // for esp8266-01

// Pin D1 --> ECHO | NodeMCU Pin D2 --> TRIGGER

//#define BLYNK_PRINT Serial    // Comment this out to disable prints and save space
#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>
#include <Blynk.h>

int maximumRange = 105; // maximum height of tank in cm
long duration;
float v;                // volume in cubic cm
float distance;         // height of water level in cm
int r = 53.2;           // radius of tank in cm
int cap;                // capacity in liters
int actual_height;      // actual height in cm

// You should get Auth Token in the Blynk App.
// Go to the Project Settings (nut icon).
char auth[] = "Your Auth Token";

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "Your SSID";
char pass[] = "Your WiFi Password";

// Keep this flag not to re-sync on every reconnection
bool isFirstConnect = true;

// This function will run every time Blynk connection is established
BLYNK_CONNECTED() {
  if (isFirstConnect) {
    // Request Blynk server to re-send latest values for all pins
    Blynk.syncAll();
    isFirstConnect = false;
  }
}
BLYNK_WRITE(V5)
{
  int pinValue = param.asInt(); // assigning incoming value from pin V1 to a variable
}
void setup() {  
  //      Serial.begin (9600);
  Blynk.begin(auth, ssid, pass);
  pinMode(TRIGGER, OUTPUT);
  pinMode(ECHO, INPUT);
}
 void loop() {
  {
  //long duration, distance;
  digitalWrite(TRIGGER, LOW);  
  delayMicroseconds(2); 
  
  digitalWrite(TRIGGER, HIGH);
  delayMicroseconds(10); 

  digitalWrite(TRIGGER, LOW);
  duration = pulseIn(ECHO, HIGH);
  distance= duration/58.2;
  delay (50);
  actual_height = maximumRange - distance;
  v = ((3.14*(r*r))*(actual_height)); // formula to calculate volume in cubic cm
  cap = v/1000; // final capacity in liters
  Blynk.virtualWrite(V5, cap);
  delay(200);
  }
   if (distance <= 105) 
   {
    Blynk.virtualWrite(V0, 255);
    //digitalWrite(D4,HIGH);
   }
    else 
    {
    Blynk.virtualWrite(V0, 0);
    //digitalWrite(D4,LOW);
    }

  if (distance <= 85) 
  {
    Blynk.virtualWrite(V1, 255);
    //digitalWrite(D5,HIGH);
    }
    else 
    {
    Blynk.virtualWrite(V1, 0);
    //digitalWrite(D5,LOW);
    }

  if (distance <= 65) 
  {
    Blynk.virtualWrite(V2, 255);
    //digitalWrite(D6,HIGH);
    }
    else 
    {
    Blynk.virtualWrite(V2, 0);
    //digitalWrite(D6,LOW);
    }

  if (distance <= 45) 
  {
    Blynk.virtualWrite(V3, 255);
    //digitalWrite(D7,HIGH);
    }
    else 
    {
    Blynk.virtualWrite(V3, 0);
    //digitalWrite(D7,LOW);
    }

  if (distance <= 20) 
  {
    Blynk.virtualWrite(V4, 255);
    //digitalWrite(D8,HIGH);
    }
    else 
    {
    Blynk.virtualWrite(V4, 0);
    //digitalWrite(D8,LOW);
    }
    
 Blynk.run();
}
